const path = require('path');
const fs = require('fs');
const ncp = require('ncp').ncp;
const config = require('../config');
const deleteFolder = require('../util/folder').deleteFolder;
const getNames = require('../util/names').getNames;

const Page = function(){

};


Page.deletePage = name => {
  const names = getNames(name);
  const { nameU ,nameC ,nameD ,name_ } = names;
  const dir = './src/routes/' + nameC;
  deleteFolder(dir);
  return names;
};

Page.createPage = (name)=>{
  const names = getNames(name);
  const { nameU ,nameC ,nameD ,name_ } = names;
  ncp(path.resolve('', config.templatePath),
      path.resolve('./src/routes/' + nameC),
      {
        /*transform: function (read, write){
          console.log('read:',read);
        }*/
      },
      function(err){
        if (err) {
          return console.error(err);
        } else {
          change();
        }
      }
  );

  function change(){
    function reName(path, ele){
      var toEle = ele.replace(/samplePage/g,nameC).replace(/SamplePage/g,nameU);
      if(toEle !== ele){
        fs.renameSync(path+"/"+ele, path+"/"+toEle);
      }
      return toEle;
    }
    function readDirSync(path){
      var pa = fs.readdirSync(path);
      pa.forEach(function(ele,index){
        ele = reName(path, ele);
        var info = fs.statSync(path+"/"+ele)
        if(info.isDirectory()){
          readDirSync(path+"/"+ele);
        }else{
          var text = fs.readFileSync(`${path}/${ele}` ,'utf-8')
          .replace(/samplePage/g, nameC)
          .replace(/SamplePage/g, nameU);
          fs.writeFileSync(`${path}/${ele}`, text, { encoding:'utf-8', flag:'w' });
        }
      })
    }
    readDirSync(path.resolve('./src/routes/' + nameC));
  }

  return names;
};

module.exports = Page;
