#!/usr/bin/env node

const chalk = require('chalk');
const program = require('commander');
const spawn = require('cross-spawn');
const join = require('path').join;
const exists = require('fs').existsSync;

if (process.argv.slice(2).join('') === '-v') {
  console.log('honey: ' + require('./package').version);
  return;
}

program
  .usage('<command> [options]')
  .on('--help', printHelp)
  .parse(process.argv);

const aliases = {
  //in: 'insert',
};
const args = process.argv.slice(3);
let subcmd = program.args[0];
if (aliases[subcmd]) subcmd = aliases[subcmd];

if (!subcmd) {
  program.help();
} else {
  const bin = executable(subcmd);
  if (bin) {
    wrap(spawn(`node`, [bin].concat(args), {stdio: 'inherit', customFds: [0, 1, 2]}));
  } else {
    program.help();
  }
}

function wrap(sp) {
  sp.on('close', function(code) {
    process.exit(code);
  });
}

function printHelp() {
  console.log('  Commands:');
  console.log('    create      创建工具，详见：honey create');
  console.log('    config      配置模板地址工具, 详见: honey config');
  console.log('    delete      删除工具, 详见: honey delete');
}

function executable(subcmd) {
  var file = join(__dirname, 'honey-' + subcmd + '.js');
  if (exists(file)) {
    return file;
  }
}
